require 'spec_helper'

module Quby::Compiler::DSL
  describe ScoreSchemaBuilder do
    let(:builder_result) do
      ScoreSchemaBuilder.build(key: :tot, label: 'Totaal') do
        subscore :value, 'Score', export_key: :tot do
          value(:v_1)
        end
      end
    end

    describe '#build' do
      it 'returns a score schema and generated score calculations' do
        schema, calculations = builder_result
        expect(schema.key).to eq(:tot)
        expect(schema.subscore_schemas.first.calculation_key).to eq(:"_tot.value")
        expect(calculations.map(&:key)).to eq([:"_tot.value", :tot])
      end
    end
  end
end
